Codeforces Round #496 (Div. 3)

1.(1005E2)http://codeforces.com/contest/1005/problem/E2

题意:给定一个长度为n的排列,先求有多少个区间[l,r]满足该区间的中位数为m

分析:设置函数count(m):表示对于给定长度为n的序列,有多少个区间的中位数是>=m的(当【区间>=m数的个数】>【区间<m的个数】时满足).最终的答案为count(m)-count(m+1)。

那么如何求解count(m)?设置变量cnt表示当前累计的值,初始值为n,当a[i]>=m时,cnt++;当a[i]<m时,cnt--。从头开始枚举区间的右端点[1,i],并计算cnt(1,i),每次只需要找出前面有多少个j满足cnt(1,j)<cnt(1,i)即可。设置sum[x]表示cnt=x的个数有多少。

那么如何求解前面有多少个数小于cnt(1,i)呢?设置变量add,表示满足cnt(1,j)<cnt(1,i-1)的数有多少。每次枚举第i位时,若a[i]>=m,则先add+=sum[cnt],cnt++。否则cnt--,add-=sum[cnt](有点类似于莫队算法中一步步更新)。每次访问一个i时,最后的答案result+=add。

参考:http://www.cnblogs.com/widsom/p/9290269.html

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 using namespace std;
 5 typedef long long ll;
 6 const int maxn=2e5+10;
 7 int a[maxn],sum[2*maxn],n;
 8
 9 ll count(int m)
10 {
11     memset(sum,0,sizeof(sum));
12     int cnt=n;
13     sum[n]=1;
14     ll add=0,result=0;
15     for ( int i=1;i<=n;i++ )
16     {
17         if ( a[i]>=m )
18         {
19             add+=sum[cnt];
20             cnt++;
21         }
22         else
23         {
24             cnt--;
25             add-=sum[cnt];
26         }
27         sum[cnt]++;
28         result+=add;
29     }
30     return result;
31 }
32
33 int main()
34 {
35     int m,i,j,k,x,y,z;
36     ll ans;
37     while ( scanf("%d%d",&n,&m)!=EOF )
38     {
39         for ( i=1;i<=n;i++ ) scanf("%d",&a[i]);
40         ans=count(m)-count(m+1);
41         printf("%lld\n",ans);
42     }
43     return 0;
44 }

1005E2

2.(1005F)http://codeforces.com/contest/1005/problem/F

题意:有n个点和m条无向边,求至多k种挑选n-1边的方案,满足根(编号为1的点)到所有点的距离之和最小,输出方案个数

分析:设置b[i]表示点i到根的最短距离(通过bfs)实现。然后对于一个点u来说考虑所有的边(u,v),若满足d[u]==d[v]+1,那么该边最终是可以选择的,设置G[u]表示u点的前驱的边中有哪些是可以选择的。设置f[i]表示对于点i当前选择第G[i][f[i]]条边,所有的f[i]初始化为0。所有对于编号为[2,n],每次挑选前驱中的一条边,最后组成的无向图是一定满足条件的。

那么如何挑选出k种方案呢?思路大致同数字中的进位(个位满10,十位加1;十位满10,百位+1。以此类推),此处也一样,f[i]==G[i].size(),f[i]==0,f[i+1]++.直到最后不能加为止

参考:http://codeforces.com/blog/entry/60511

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 #include<vector>
 5 #include<queue>
 6 #include<string>
 7 #include<iostream>
 8 using namespace std;
 9 const int maxn=2e5+10;
10 const int inf=1e9;
11 vector<int>E[maxn],G[maxn];
12 vector<string>ans;
13 int a[maxn],b[maxn],f[maxn],d[maxn],n;
14
15 void BFS()
16 {
17     for ( int i=1;i<=n;i++ ) d[i]=inf;
18     d[1]=0;
19     queue<int>que;
20     que.push(1);
21     while ( !que.empty() )
22     {
23         int u=que.front();
24         que.pop();
25         for ( int i=0;i<E[u].size();i++ )
26         {
27             int v=E[u][i];
28             if ( d[v]==inf )
29             {
30                 d[v]=d[u]+1;
31                 que.push(v);
32             }
33         }
34     }
35 }
36
37 int main()
38 {
39     int m,k,i,j,x,y,z,u,v,cnt;
40     while ( scanf("%d%d%d",&n,&m,&k)!=EOF )
41     {
42         ans.clear();
43         for ( i=1;i<=n;i++ )
44         {
45             E[i].clear();
46             G[i].clear();
47         }
48         for ( i=1;i<=m;i++ )
49         {
50             scanf("%d%d",&a[i],&b[i]);
51             E[a[i]].push_back(b[i]);
52             E[b[i]].push_back(a[i]);
53         }
54         BFS();
55         for ( i=1;i<=m;i++ )
56         {
57             u=a[i],v=b[i];
58             if ( d[u]==d[v]+1 ) G[u].push_back(i);
59             if ( d[v]==d[u]+1 ) G[v].push_back(i);
60         }
61         memset(f,0,sizeof(f));
62         cnt=0;
63         for ( j=1;j<=k;j++ )
64         {
65             string s(m,‘0‘);
66             for ( i=2;i<=n;i++ )
67             {
68                 s[G[i][f[i]]-1]=‘1‘;
69             }
70             ans.push_back(s);
71             bool ok=false;
72             for ( i=2;i<=n;i++ )
73             {
74                 if ( f[i]+1<G[i].size() )
75                 {
76                     ok=true;
77                     f[i]++;
78                     break;
79                 }
80                 else f[i]=0;
81             }
82             if ( !ok ) break;
83         }
84         cout<<ans.size()<<endl;
85         for ( i=0;i<ans.size();i++ ) cout<<ans[i]<<endl;
86     }
87     return 0;
88 }

1005F

原文地址:https://www.cnblogs.com/HDUjackyan/p/9293613.html

时间: 2024-11-08 11:20:59

Codeforces Round #496 (Div. 3)的相关文章

Codeforces Round #496 (Div. 3) ABCDE1

1 //B. Delete from the Left 2 #include <iostream> 3 #include <cstdio> 4 #include <cstring> 5 #include <algorithm> 6 #include <set> 7 #include <map> 8 #include <vector> 9 using namespace std; 10 const int inf=0x3f3

Codeforces Round #496 (Div. 3)A~F

(寒假训练赛,也是lj难得补完的一场 https://codeforces.com/contest/1005 A.题意是  每一个楼梯有x个台阶,小女孩爬楼的时候会从1开始数每层楼有几个台阶,现在给给出n个数字a1~an,代表着小女孩爬楼时数数的序列,求有多少层楼梯,并且输出每层楼梯台阶数. 解法:for循环模拟小女孩从1开始数,数到下一个1的话楼层++,然后把他前一个数存进去. int now = 0; for(int i = 0;i < n;++i){ cin>>a; if(a ==

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f

Codeforces Round #315 (Div. 1)

A. Primes or Palindromes? time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Rikhail Mubinchik believes that the current definition of prime numbers is obsolete as they are too complex and un